Loading...
Searching...
No Matches
Qore::FileInputStream Class Reference

This class implements the InputStream interface for reading bytes from a file. More...

`#include <QC_FileInputStream.dox.h>`

Inheritance diagram for Qore::FileInputStream:
[legend]

## Public Member Functions

| constructor (string fileName, timeout timeout_ms=-1, *bool nonblocking_open)
| Creates the FileInputStream by opening a file.
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available.
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor.
abstract int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available.
abstract *binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses.
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation.
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation.

## Detailed Description

This class implements the InputStream interface for reading bytes from a file.

Restrictions:
  Qore::PO_NO_FILESYSTEM

Example: FileInputStream basic usage
  FileInputStream fis("file.ext");
  binary *b;
  while (b = fis.read(100)) {
  printf("read %s\n", make_hex_string(b));
  }

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

Since
  Qore 0.8.13

## Member Function Documentation

## constructor()

Qore::FileInputStream::constructor | ( | string | fileName,
|  | timeout | timeout_ms = `-1`,
|  | *bool | nonblocking_open
| ) |  |

Creates the FileInputStream by opening a file.

Parameters

  fileName | the name of the file to open
  timeout_ms | a timeout period with a resolution of milliseconds (a relative date/time value; integer arguments will be assumed to be milliseconds); if not given or negative the operations will never time out
  nonblocking_open | if True, then the `O_NONBLOCK` flag will be set in the call to `open() (2)`

Exceptions

  FILE-OPEN2-ERROR | if the file cannot be opened (does not exist, permission error, etc)

Since
  Qore 0.9.3 added the nonblocking_open flag

## peek()

int Qore::FileInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  FileInputStream fis("file.ext");
  int nextByte = fis.peek();

Exceptions

  FILE-READ-ERROR | if an I/O error occurs
  FILE-READ-TIMEOUT-ERROR | if no byte could be read in the timeout specified in the constructor
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.

## read()

*binary Qore::FileInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Example:
  FileInputStream fis("file.ext");
  *binary b;
  while (b = fis.read(2)) {
  printf("read %s\n", make_hex_string(b));
  }

Exceptions

  FILE-READ-ERROR | if an I/O error occurs
  FILE-READ-TIMEOUT-ERROR | if no byte could be read in the timeout specified in the constructor
  INPUT-STREAM-ERROR | limit is not positive
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

See also
  FileInputStream::readString()

Implements Qore::InputStream.